#!/bin/sh
echo "Content-type: text/html";
echo;
echo "<HTML><TITLE>MPS Audio Extraction</TITLE><BODY>";
cd /mnt/flash

errMsg="<BR>Please use your browser's <B>back</B> button to correct the error.<BR>";

#
# Read CGI data
#
read data_in

#
# Parse the input data
#
if [ "X$data_in" != "X" ]; then
	#
	# Input checking
	#
	#echo "Got $data_in"
	newMpsIp=`echo $data_in | sed -n "s/.*\(newMpsIp=\)\([^\&]*\).*/\2/p"`
	newMpsPort=`echo $data_in | sed -n "s/.*\(newMpsPort=\)\([^\&]*\).*/\2/p"`
	newMpsExtractEna=`echo $data_in | sed -n "s/.*\(newMpsExtractEna=\)\([^\&]*\).*/\2/p"`
    
	# check IP addresses
    i=1;
    while [ $i -lt 5 ]; do
		byte=`echo $newMpsIp | sed -n 's/^\([0-9]*\).\([0-9]*\).\([0-9]*\).\([0-9]*\)$/\'$i'/p'`;
		if [ "X$byte" = "X" ]; then
			echo "IP address misconfiguration ($newExgineIp)<BR>$errMsg";
			exit;
		fi
		if [ $byte -gt 255 ]; then
			echo "IP address misconfiguration ($newExgineIp)<BR>$errMsg";
			exit;
		fi
		
		
		let i=i+1;
	done
	
    if [ "X$newMpsExtractEna" != "X1" ]; then
        newMpsIp="0.0.0.0";
    fi
    
    if [ $newMpsPort -lt 0 ]; then
        newMpsPort="4444";
    fi
    
			
	#
	# Update configuration files
	#
    
	killall -q -2 exgined
    
	cp -f /mnt/flash/exgine.cfg /tmp/exgine.cfg
	
	sed -e	"s/\(mpsIp:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newMpsIp\2/" /tmp/exgine.cfg >  /tmp/exgine2.cfg
	sed -e	"s/\(mpsPort:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newMpsPort\2/" /tmp/exgine2.cfg > /tmp/exgine.cfg
        
	cat /proc/flash_write_enable > /dev/null
	mount -o remount,rw /mnt/flash
	
	if [ -e /mnt/flash/exgine.cfg ] ; then 
		cp -f /mnt/flash/exgine.cfg /mnt/flash/exgine.cfg.bkup
	fi
	cp -f /tmp/exgine.cfg /mnt/flash/exgine.cfg
	
	mount -o remount,ro /mnt/flash
	cat /proc/flash_write_disable > /dev/null
	
	echo "<P><B>Note:</B> Changes have been applied.  A <A HREF="reboot.sh">reboot</A> is required for these changes to take effect.<P>";
	
fi

#
# Read configuration file settings
#

# exgine IP address
mpsIp=`sed -n "s/\(mpsIp:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
mpsPort=`sed -n "s/\(mpsPort:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;

if [ "X$mpsIp" = "X0.0.0.0" ]; then
    mpsExtractEna="0";
else
    mpsExtractEna="1";
fi


#
# Build the HTML page
#
echo "<FORM METHOD=POST ACTION=mpsextract.sh>"

echo "<TABLE WIDTH=80% CELLSPACING=0 CELLPADDING=4>"

echo "<TR><TD bgcolor=\"#09254a\"><FONT color=gray FACE=\"Verdana\"><B>MPS Audio Extraction</B></FONT></TD>";
echo "<TD ALIGN=right bgcolor=\"#09254a\"><A HREF=\"/mpsextract_hlp.html\" TRAGET=_blank><FONT color=gray FACE=\"Verdana\"><B>[help]</b></FONT></A></TD></TR>";
echo "<TR><TD VALIGN=top><B>Enable MPS Audio Extraction</B></TD><TD VALIGN=top>"

if [ "X$mpsExtractEna" = "X1" ]; then
	defaultena="CHECKED";
	defaultdis="";
else
	defaultena="";
	defaultdis="CHECKED";
fi


echo "<INPUT TYPE=RADIO NAME=newMpsExtractEna VALUE=\"1\" $defaultena> enabled<BR>"
echo "<INPUT TYPE=RADIO NAME=newMpsExtractEna VALUE=\"0\" $defaultdis> disabled<BR>"
echo "</TD></TR>";
	usleep 50000



echo "<TR><TD><B>Send Audio to IP Address</B></TD><TD><INPUT TYPE=text NAME=newMpsIp VALUE=\"$mpsIp\"></TD></TR>";
echo "<TR><TD><B>Send on Port Number</B></TD>     <TD><INPUT TYPE=text NAME=newMpsPort VALUE=\"$mpsPort\"></TD></TR>";

echo "<TR></TR></TABLE>";
echo "<INPUT TYPE=submit VALUE=\"Accept Changes\" >"
echo "<INPUT TYPE=reset VALUE=\"Clear Changes\" >"
echo "</FORM>"
echo "<P><B>Note:</B> <BR> Submitting configuration changes will suspend exgine operation until the system is restarted. Not all configuration modes allow for MPS extraction.  Contact Nautel customer service to confirm your operating mode prior to enabling this feature.<P>";
echo "</BODY>"
echo "</HTML>"

















