#!/bin/sh
echo "Content-type: text/html";
echo;
echo "<HTML><TITLE>Exgine Platform Configuration</TITLE><BODY>";
cd /mnt/flash

errMsg="<BR>Please use your browser's <B>back</B> button to correct the error.<BR>";

#
# Read CGI data
#
read data_in

#
# Parse the input data
#
if [ "X$data_in" != "X" ]; then
	#
	# Input checking
	#
    
    #########################################################
    #
    # Platform Choices
    #   1   Nautel M50 FM Exciter
    #   2   Nautel Reliable HD Transport Unit
    #   3   Nautel NX AM Transmitter
    #   4   Nautel AM IBOC Exciter
    #   5   Nautel NV FM Exciter
    #   6   Nautel NV FM Exciter with HD Power Boost
    #
    # Drives the following configuration parameters
    #
    #  - exgineMode
    #  - usenewserialprotocol  
    #  - e2xTransportMode
    #
    #########################################################
    
	#echo "Got $data_in"
	newPlatform=`echo $data_in | sed -n "s/.*\(newPlatform=\)\([^\&]*\).*/\2/p"`
    
	# check IP addresses
    if [ $newPlatform -lt 0 ]; then
        newPlatform=0;
    fi
    if [ $newPlatform -gt 6 ]; then
        newPlatform=0;
    fi
    
    
    # now derive configuration parameters
    newUsenewserialprotocol=`sed -n "s/\(usenewserialprotocol:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
    newExgineMode=`sed -n "s/\(exgineMode:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
    newE2xTransportMode=`sed -n "s/\(e2xTransportMode:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
    newConstantRmsOutput=`sed -n "s/\(constantRmsOutput:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
    newLvdsDriveSymbolStart=`sed -n "s/\(lvdsDriveSymbolStart:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
    newParEnable=`sed -n "s/\(parEnable:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
    newIqScaleFactor=`sed -n "s/\(iqScaleFactor:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
    
    # Nautel M50 FM Exciter
    if [ $newPlatform -eq 1 ]; then
        newUsenewserialprotocol="disabled";
        newExgineMode=0;
        newE2xTransportMode="disabled";
        newConstantRmsOutput="enabled";
        newLvdsDriveSymbolStart="disabled";
        newParEnable="enabled";
        newIqScaleFactor=400;
    fi

    # Nautel Reliable HD Transport Unit
    if [ $newPlatform -eq 2 ]; then
        newUsenewserialprotocol="disabled";
        newExgineMode=0;
        newE2xTransportMode="enabled";
        newConstantRmsOutput="enabled";
        newLvdsDriveSymbolStart="disabled";
        newParEnable="enabled";
        newIqScaleFactor=400;
    fi

    # Nautel NX AM Transmitter
    if [ $newPlatform -eq 3 ]; then
        newUsenewserialprotocol="enabled";
        newExgineMode=1;
        newE2xTransportMode="disabled";
        newConstantRmsOutput="enabled";
        newLvdsDriveSymbolStart="disabled";
        newParEnable="enabled";
        newIqScaleFactor=400;
    
    fi
    
    # Nautel AM IBOC Exciter
    if [ $newPlatform -eq 4 ]; then
        newUsenewserialprotocol="enabled";
        newExgineMode=1;
        newE2xTransportMode="disabled";
        newConstantRmsOutput="enabled";
        newLvdsDriveSymbolStart="disabled";
        newParEnable="enabled";
        newIqScaleFactor=400;

    fi

    # Nautel NV FM Exciter
    if [ $newPlatform -eq 5 ]; then
        newUsenewserialprotocol="enabled";
        newExgineMode=0;
        newE2xTransportMode="disabled";
        newConstantRmsOutput="enabled";
        newLvdsDriveSymbolStart="disabled";
        newParEnable="enabled";
        newIqScaleFactor=400;
    fi

    # Nautel NV FM Exciter with HD Power Boost
    if [ $newPlatform -eq 6 ]; then
        newUsenewserialprotocol="enabled";
        newExgineMode=0;
        newE2xTransportMode="disabled";
        newConstantRmsOutput="disabled";
        newLvdsDriveSymbolStart="enabled";
        newParEnable="disabled";
        newIqScaleFactor=300;
    fi
			
	#
	# Update configuration files
	#
    
	killall -q -2 exgined
    
	cp -f /mnt/flash/exgine.cfg /tmp/exgine2.cfg
	sed -e	"s/\(usenewserialprotocol:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newUsenewserialprotocol\2/" /tmp/exgine2.cfg > /tmp/exgine.cfg
	sed -e	"s/\(exgineMode:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newExgineMode\2/" /tmp/exgine.cfg > /tmp/exgine2.cfg
	sed -e	"s/\(e2xTransportMode:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newE2xTransportMode\2/" /tmp/exgine2.cfg > /tmp/exgine.cfg
	sed -e	"s/\(constantRmsOutput:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newConstantRmsOutput\2/" /tmp/exgine.cfg > /tmp/exgine2.cfg
	sed -e	"s/\(lvdsDriveSymbolStart:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newLvdsDriveSymbolStart\2/" /tmp/exgine2.cfg > /tmp/exgine.cfg
	sed -e	"s/\(parEnable:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newParEnable\2/" /tmp/exgine.cfg > /tmp/exgine2.cfg
	sed -e	"s/\(iqScaleFactor:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newIqScaleFactor\2/" /tmp/exgine2.cfg > /tmp/exgine.cfg
        
	cat /proc/flash_write_enable > /dev/null
	mount -o remount,rw /mnt/flash
	
	if [ -e /mnt/flash/exgine.cfg ] ; then 
		cp -f /mnt/flash/exgine.cfg /mnt/flash/exgine.cfg.bkup
	fi
	cp -f /tmp/exgine.cfg /mnt/flash/exgine.cfg
	
	mount -o remount,ro /mnt/flash
	cat /proc/flash_write_disable > /dev/null
	
	echo "<P><B>Note:</B> Changes have been applied.  A <A HREF="reboot.sh">reboot</A> is required for these changes to take effect.<P>";
	
fi

#
# Don't read configuration file settings
#

#
# Build the HTML page
#
echo "<FORM METHOD=POST ACTION=platformcfg.sh>"

echo "<TABLE WIDTH=80% CELLSPACING=0 CELLPADDING=4>"

echo "<TR><TD bgcolor=\"#09254a\"><FONT color=gray FACE=\"Verdana\"><B>Exgine Platform Configuration</B></FONT></TD>";
echo "<TD ALIGN=right bgcolor=\"#09254a\"></TD></TR>";
echo "<TR><TD VALIGN=top><B>Select the product the Exgine card resides in:</B></TD><TD VALIGN=top>"
	usleep 50000


echo "<SELECT NAME=newPlatform>"
echo "<OPTION VALUE=\"0\">Select Product Platform"
echo "<OPTION VALUE=\"1\">Nautel M50 FM Exciter"
echo "<OPTION VALUE=\"2\">Nautel Reliable HD Transport Unit"
echo "<OPTION VALUE=\"3\">Nautel NX AM Transmitter"
echo "<OPTION VALUE=\"4\">Nautel AM IBOC Exciter"
echo "<OPTION VALUE=\"5\">Nautel NV FM Exciter (no HD Power Boost)"
echo "<OPTION VALUE=\"6\">Nautel GV/NV/VSHD FM Exciter (with HD Power Boost)"
echo "</SELECT><BR>"
echo "</TD></TR>";
	usleep 50000


echo "<TR></TR></TABLE>";
echo "<INPUT TYPE=submit VALUE=\"Configure Exgine\" >"
echo "</FORM>"
echo "<P><B>Note:</B> <BR> Platform only needs to be configured on initial exgine installation or after a software upgrade.<BR>An exgine restart is required after.<P>";
echo "</BODY>"
echo "</HTML>"

















